/*
 * Routines used for minimisation (only)
 */

#ifndef MINIMISE_H
#define MINIMISE_H

#include "mgraph.h"

double compute_energy(const struct Vertices *vs);

double graph_layout_cost(const Vertices v);
void graph_layout_prepare();

void compute_vertex_areas(const Vertices vertices);
void compute_edge_lengths(const Vertices vertices);
extern double vertex_areas[N], vertex_mean_edge_lengths[N], edge_lengths[N][V6];

double noncircular_rim_cost(const Vertices vertices);
double edgewise_vertex_displacement_cost(const Vertices vertices);
double edge_length_variation_cost(const Vertices vertices);

extern const char *input_file, *output_file;
extern char *output_file_tmp;

enum printing_instance { pr_cost, pr_size, pr__max };
int printing_check(enum printing_instance, int indent);

#endif /*MINIMISE_H*/
